package com.muyu.context;

import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.GetObjectRequest;
import com.muyu.common.security.utils.SecurityUtils;
import com.muyu.domain.EngineMaintenance;
import com.muyu.domain.EngineVersion;
import com.muyu.domain.constants.Result;
import org.springframework.stereotype.Component;

import javax.tools.JavaCompiler;
import javax.tools.ToolProvider;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

@Component
public class GenerateConstant {

    public static final String DATA_FIELD = "DataEngineValueActuator";
    public static final String DATA_RECORD = "DataEngineRecordActuator";
    public static final String DATA_SET = "DataEngineSetActuator";
    public static final String ACTION_IMPORT = "import com.muyu.abstracts.DataValue;";
    public static final String SCOPE_IMPORT = "import com.muyu.engine.basic.abstracts.";
    public static final String PACKAGE_PATH = "package com.muyu.generate;\n";
    private static final String endpoint = "https://oss-cn-shanghai.aliyuncs.com";

    private static final String accessKeyId = "LTAI5t8LmMHfW8ckPaAZR6oQ";

    private static final String accessKeySecret = "pwzEwkpxcTFgurkARyr7sG7V6syc9x";

    private static final String bucketName = "011811";
    // OSS文件路径
    private static final String filePath = "build/rule/version/";

    private static final String fileName = "engine";

    public static String getClassName(String versionCode) {
        String[] splits = versionCode.split("_");
        String className = "";
        for (String split : splits) {
            className += split.substring(0, 1).toUpperCase() + split.substring(1);
        }
        return className;
    }

    public static String generateConstant(EngineMaintenance ruleData, EngineVersion ruleVersion) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        String format = simpleDateFormat.format(new Date());
        String level = selectType(ruleData.getScope());
        return PACKAGE_PATH + "\n" +
                ACTION_IMPORT + "\n" +
                SCOPE_IMPORT + level + ";\n" +
                "\n" +
                "/**\n" +
                " * @Author: " + SecurityUtils.getUsername() + "\n" +
                " * @date: " + format + "\n" +
                " * @Description: " + ruleVersion.getName() + "_" + ruleVersion.getVersionCode() + "\n" +
                " * @Version: 1.0\n" +
                " */\n" +
                "public class " + getClassName(ruleVersion.getVersionCode()) + " extends " + "DataEngineRowActuator" + " {\n" +
                "    @Override\n" +
                "    public void run () {\n" +
                "if(DataValue.getValue==null)\n{" +
                "\nthrow new RuntimeException(\"数据不能为空!!!\");\n}\n"+
                "    }\n" +
                "}";
    }

    public static String selectType(String level) {
        String type = "";
        switch (level) {
            case "F":
                type = DATA_FIELD;
                break;
            case "R":
                type = DATA_RECORD;
                break;
            case "C":
                type = DATA_SET;
                break;
        }
        return type;
    }

}
