package com.muyu.remote;

import com.muyu.domain.EngineVersion;
import com.muyu.domain.constants.Result;
import com.muyu.req.EngineVersionQueryReq;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

/**
 * @Author：qdm
 * @Package：com.muyu.remote
 * @Project：cloud-etl-engine
 * @name：RemoteVersionService
 * @Date：2024/8/29 10:54
 */
@FeignClient(name = "cloud-etl-server")
public interface RemoteVersionService {

    @GetMapping("/version/getVersion/{id}")
    public Result<EngineVersion> getVersion(@PathVariable("id") Long id);

    @GetMapping("/version/list")
    public Result<List<EngineVersion>> list(EngineVersionQueryReq engineConfigQueryReq);

    @GetMapping("/version/selectVersionList")
    public Result<List<EngineVersion>> selectVersionList();
}
