package com.muyu.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.EngineMaintenance;
import com.muyu.domain.EngineVersion;
import com.muyu.domain.model.TestData;
import com.muyu.req.VersionClassCreateReq;
import com.muyu.resp.EngineConfigScopeResp;
import com.muyu.resp.VersionClassCreateResp;

import java.util.List;

/**
 * @Author：qdm
 * @Package：com.muyu.service
 * @Project：cloud-etl-engine
 * @name：EngineVersionService
 * @Date：2024/8/22 21:57
 */
public interface EngineVersionService extends IService<EngineVersion> {

    /**
     * 查询引擎规则配置列表
     *
     * @param engineConfig 引擎规则配置
     * @return 引擎规则配置集合
     */
    public List<EngineVersion> list(EngineVersion engineConfig);

    EngineVersion updateMsg(EngineVersion engineVersion);

    Result<EngineVersion> updateVersion(EngineVersion engineVersion);

    List<EngineConfigScopeResp> getScopeList();

    EngineConfigScopeResp getScopeInfoById(Integer id);

    Object ruleTest(TestData testData);

    VersionClassCreateResp createVersionClass(VersionClassCreateReq req);

    Result<EngineVersion> add(EngineVersion engineVersion);

    List<EngineMaintenance> getByIds(Integer versionId);

    boolean insert(EngineVersion engineVersion);

    void onEngine(Integer id);

    void close(Integer id);
}
